﻿using System.Web.Mvc;

namespace HeuristicLab.Services.WebApp.Controllers {

  public class AppController : Controller {

    public ActionResult Index() {
      if (!Request.Path.EndsWith("/")) {
        return RedirectPermanent(Request.Url + "/");
      }
      return View("~/WebApp/shared/layout/layout.cshtml");
    }

    public ActionResult Empty() {
      return View("~/WebApp/shared/restricted/empty.cshtml");
    }

    public ActionResult LoadSharedView(string directory, string view, string dateTime) {
      // dateTime is optional to avoid browser caching
      return View(string.Format("~/WebApp/shared/{0}/{1}", directory, view));
    }

    public ActionResult LoadPluginView(string plugin, string view, string dateTime) {
      // dateTime is optional to avoid browser caching
      return View(string.Format("~/WebApp/plugins/{0}/{1}", plugin, view));
    }

  }
}