﻿var appMainModule = app.registerModule(appName);
appMainModule.dependencies = ['oc.lazyLoad', 'ui.router', 'angular-loading-bar', 'ngResource'];
appMainModule.loadModule();
(function () {
    'use strict';
    var module = appMainModule.getAngularModule();

    module.config(['$ocLazyLoadProvider', function ($ocLazyLoadProvider) {
        app.modules.forEach(function (module) {
            $ocLazyLoadProvider.config({
                modules: [{
                    name: module.getFullModuleName(),
                    files: module.getFiles()
                }]
            });
        });
    }]);

    module.config([
        '$stateProvider', '$urlRouterProvider',
        function ($stateProvider, $urlRouterProvider) {
            $urlRouterProvider.otherwise('/status');
            // load module routes
            app.modules.forEach(function (module) {
                // home route
                $stateProvider.state(module.name, {
                    url: module.getRouteName(),
                    controller: module.getController(),
                    templateUrl: module.getViewUrl(module.getView()),
                    cache: false,
                    resolve: {
                        loadModule: ['$ocLazyLoad', 'cfpLoadingBar', function ($ocLazyLoad, cfpLoadingBar) {
                            cfpLoadingBar.start();
                            var retVal = module.loadModule($ocLazyLoad);
                            cfpLoadingBar.complete();
                            return retVal;
                        }]
                    }
                });
                // sub-routes
                module.configureRoutes($stateProvider);
            });
        }
    ]);

    module.config([
        '$httpProvider', function ($httpProvider) {
            $httpProvider.interceptors.push(['$q', function ($q) {
                return {
                    'request': function (config) {
                        if (endsWith(config.url, '.cshtml')) {
                            config.url = 'App/LoadPluginView?' + config.url + "&dateTime=" + Date.now().toString();
                        }
                        return config;
                    }
                };
            }]);
        }
    ]);

    function endsWith(str, suffix) {
        if (suffix.length > str.length) {
            return false;
        }
        return str.indexOf(suffix, str.length - suffix.length) !== -1;
    }

})();